import dds
import ddsutil
import struct

class Accel___TypeSupport(dds.TypeSupport):

    _typename = 'geometry_msgs::msg::dds_::Accel_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct><Struct name="Accel_"><Member name="linear_"><Type name="Vector3_"/></Member><Member name="angular_"><Type name="Vector3_"/></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(Accel___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(Accel_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, Accel_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = Accel_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class Accel_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return Accel___TypeSupport()

    @property
    def linear_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Vector3_ value
        @rtype: Vector3_
        '''
        return self._linear__

    _linear__checker = ddsutil._class_checker(Vector3_)
    @linear_.setter
    def linear_(self, value):
        self._linear__checker(value)
        self._linear__ = value

    @property
    def angular_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Vector3_ value
        @rtype: Vector3_
        '''
        return self._angular__

    _angular__checker = ddsutil._class_checker(Vector3_)
    @angular_.setter
    def angular_(self, value):
        self._angular__checker(value)
        self._angular__ = value

    _member_attributes = ('linear_', 'angular_')

    def __init__(self, **kwargs):
        ''' Create a Accel_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.linear_ = Vector3_()
        self.angular_ = Vector3_()
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if Accel_._packing_fmt is not None:
            return Accel_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, Vector3_._get_packing_fmt())
        fmt += ddsutil._align(fmt, Vector3_._get_packing_fmt())

        Accel_._packing_fmt = ddsutil._pad_fmt(fmt)
        return Accel_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.linear_ = Vector3_()._deserialize(data)
        self.angular_ = Vector3_()._deserialize(data)
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.linear_._get_packing_args())
        args.extend(self.angular_._get_packing_args())
        return args

